package Group8Project;

/*
 * Copyright (c) 2017 University of North Carolina at Charlotte
 * 9201 University City Blvd, Charlotte, NC, 28223-0001, U.S.A.
 * All rights reserved.
 */
import java.io.*;
import java.net.ServerSocket;
import java.net.Socket;
import java.io.DataOutputStream;
import java.io.IOException;
/**
 * ITCS 3166
 * Intro to Computer Networks
 *  
 * USED ELEMENTS OF CODE FROM EXAMPLE
 * @author Ria, Priyank, Paras
 */

class WebServer implements Runnable{
    private int sPortNum;
    private String sName;
    private ServerSocket sSocket;
    private boolean isDisconnected = false;
    private String strMessage = "";
    
    WebServer(int portNum, String name) {
        sPortNum = portNum;
        sName = name;
    }
    
    public void run(){
        Socket cSocket = null;
        synchronized (this) {
           Thread runningThread = Thread.currentThread();
        }
        openServerSocket();
        
        int count = 0;
        while(isDisconnected != true){
            try{
                cSocket = sSocket.accept();
                count++;
            }catch(IOException e){
                if(isDisconnected){
                    System.err.println("Server has Disconnected");
                }
            }
            try{
                if (count > 0){
                    processClientRequest(cSocket, false);  
                }
                else{
                    processClientRequest(cSocket, true);
                }
            }catch(IOException e){
                throw new RuntimeException("Problem processing the client's request. Please try again");
            }
        }       
    }
    
    
    private void processClientRequest(Socket cSocket, boolean creation) throws IOException{
        InputStream iStream = cSocket.getInputStream();
        OutputStream oStream = cSocket.getOutputStream();
        
        long timer = System.currentTimeMillis();
        
        if (creation == true){
            oStream.write(("HTTP/1.1 200 OK\n\n<html><h1>" + "Request has been recieved </h1>").getBytes());
            oStream.write(("\n</h1>Server Name: " + sName + "\nStatus: Idle</h1></html>").getBytes());
            oStream.write(("\n</h1>Time: "+ timer + "</h1></html>").getBytes());
        }
        else if(strMessage.equals("")){
            oStream.write(("HTTP/1.1 200 OK\n\n<html><h1>Server Name: " + sName + "</h1>").getBytes());
            oStream.write(("\n</h1>Status: Idle</h1></html>").getBytes());
        }
        else{
            oStream.write(("HTTP/1.1 200 OK\n\n<html><h2>Server Name: " + sName + "</h2>").getBytes());
            oStream.write(("\n</h2>Status: Message has been recieved</h2></html>").getBytes());
            oStream.write(("\n</h2>Message: "+ strMessage + "</h2></html>").getBytes());
        }
        oStream.close();
        iStream.close();
    }
    
    private void openServerSocket(){
        try{
            sSocket = new ServerSocket(sPortNum);
        }catch(IOException e){
            throw new RuntimeException("Sorry we couldn't open the port. Try a new Number.");
        }
    }
        
    void sendMessage(String str){
        strMessage = str;
    }
    
    synchronized void stopServer(){
        isDisconnected = true;
        try{
            sSocket.close();
        }catch(IOException e){
            throw new RuntimeException("There was a problem closing the server. Please try again");
        }
    }
    
    synchronized boolean isDisconnected(){
        return isDisconnected;
    }
}
